#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <stdio.h>
#include <math.h>

void writeToFile(HANDLE file, const char* data) {
    DWORD bytesWritten;
    WriteFile(file, data, strlen(data), &bytesWritten, NULL);
}

void readFromFile(HANDLE file, char* buffer, DWORD size) {
    DWORD bytesRead;
    ReadFile(file, buffer, size - 1, &bytesRead, NULL);
    buffer[bytesRead] = '\0'; //  
}

int main() {
    setlocale(LC_ALL, "Russian");

    HANDLE file1 = CreateFile(L"coefOUT.txt", GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    HANDLE file = CreateFile(L"coef.txt", GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

    if (file == INVALID_HANDLE_VALUE) {
        fprintf(stderr, "   coef.txt: %lu\n", GetLastError());
        return EXIT_FAILURE;
    }

    if (file1 == INVALID_HANDLE_VALUE) {
        fprintf(stderr, "   coefOUT.txt: %lu\n", GetLastError());
        CloseHandle(file);
        return EXIT_FAILURE;
    }

    char line[256];
    double coef[3];
    int coefCount = 0; //  

    while (1) {
        readFromFile(file, line, sizeof(line)); //    

        //    
        if (strlen(line) == 0) {
            break; //   ,   
        }

        char* token = strtok(line, " \n");

        //  
        while (token != NULL) {
            coef[coefCount] = atof(token);
            coefCount++;

            //    3 ,  
            if (coefCount == 3) {
                double x1, x;
                double a = coef[0];
                double b = coef[1];
                double c = coef[2];

                char output[256];
                snprintf(output, sizeof(output), ": %f %f %f\n", a, b, c);
                writeToFile(file1, output);

                double D = b * b - 4 * a * c;

                if (a == 0 && b == 0 && c == 0) {
                    snprintf(output, sizeof(output), "       \n");
                    writeToFile(file1, output);
                }
                else if (D > 0) {
                    x1 = (-b + sqrt(D)) / (2 * a);
                    x = (-b - sqrt(D)) / (2 * a);
                    snprintf(output, sizeof(output), ": x1 = %f, x2 = %f\n", x1, x);
                    writeToFile(file1, output);
                }
                else if (D == 0) {
                    x = -b / (2 * a);
                    snprintf(output, sizeof(output), ": %f\n", x);
                    writeToFile(file1, output);
                }
                else {
                    snprintf(output, sizeof(output), " \n");
                    writeToFile(file1, output);
                }

                //      
                coefCount = 0;
            }

            token = strtok(NULL, " \n");
        }
    }

    //   ,    
    if (coefCount > 0) {
        char output[256];
        snprintf(output, sizeof(output), "    \n");
        writeToFile(file1, output);
    }

    CloseHandle(file);
    CloseHandle(file1);
    return EXIT_SUCCESS;
}